﻿// SameItemsSelection.jsx


// Esp
/*
El guion selecciona objetos en el pliego actual que coinciden con el diseño del marco seleccionado ('referencia').
Se comprueban los elementos de diseño del objeto de referencia, que serán los criterios de coincidencia.
Luego de hacer clic en el botón 'Buscar objetos', se resaltarán los marcos que coincidan con el estándar, de acuerdo con los criterios seleccionados.

La búsqueda se realiza solo entre objetos individuales de los tipos 'Marco de texto', 'Rectángulo', 'Polígono', 'Línea gráfica' y 'Óvalo'. El objeto anclado puede ser una referencia, pero no se incluirá en el grupo de objetos encontrados. Los grupos están excluidos de la consideración.

Los criterios 'Relleno' y 'Trazo' tienen en cuenta los colores y el porcentaje de relleno de los objetos. En cuanto a la línea de contorno, además de los colores y las sombras, se comparan grosores de línea, pero no se analiza el tipo de línea.
En el criterio 'Mismo tamaño' la diferencia de tamaño no excede un punto. El programa analiza las dimensiones del objeto (cuadro delimitador), no el tamaño real; dos cuadrados idénticos girados en diferentes ángulos tendrán dimensiones no coincidentes y, por esta razón, no se mostrarán como objetos del mismo tamaño.
Si la casilla de verificación 'Objetos del mismo tipo' está seleccionada, la ventana emergente de la casilla, luego de realizar la búsqueda, contendrá el nombre del tipo del objeto seleccionado.

El resultado de la búsqueda es un grupo seleccionado de objetos o un mensaje que indica que no se encontraron coincidencias. Si se encuentra alguna, se informa su cantidad en la ventana emergente del botón [?].

La referencia elegida se incluirá o no en la selección (si no es un objeto anclado), según el estado de la casilla de verificación a la izquierda del botón 'Buscar objetos'.
Mientras la selección basada en los resultados de la búsqueda esté activa, puede usar esta casilla de verificación para colocar el estándar de búsqueda en la selección o excluirlo de ella.
Cada vez que se cambia esta casilla de verificación, el color de relleno del cuadro de referencia cambia en la secuencia rojo-verde-azul, y luego se regresa al color original; este es un recordatorio de qué marco se seleccionó antes de buscar objetos similares.

https://shop.dotextok.ru/en/  |  dotextok@gmail.com   
    
*/

var m01 = "Objetos similares";
var m02 = "Criterios de coincidencia:";
var m03 = "Relleno";
var m04 = "Trazo";
var m05 = "Coincidencia de estilos de objetos";
var m06 = "Objetos en la misma capa";
var m07 = "Objetos del mismo tipo";
var m08 = "Mismo tamaño";
var m09 = "Ignorar capas bloqueadas";
var m10 = "Con la casilla de verificación seleccionada el objeto de referencia no se incluye en la selección";
var m11 = "Buscar objetos";
var m12 = "El guion selecciona objetos en el pliego actual que coinciden con el diseño del marco seleccionado ('referencia').\nSe comprueban los elementos de diseño del objeto de referencia, que serán los criterios de coincidencia.\nLuego de hacer clic en el botón 'Buscar objetos', se resaltarán los marcos que coincidan con el estándar, de acuerdo con los criterios seleccionados.\n\nLa búsqueda se realiza solo entre objetos individuales de los tipos 'Marco de texto', 'Rectángulo', 'Polígono', 'Línea gráfica' y 'Óvalo'. El objeto anclado puede ser una referencia, pero no se incluirá en el grupo de objetos encontrados. Los grupos están excluidos de la consideración.\n\nLos criterios 'Relleno' y 'Trazo' tienen en cuenta los colores y el porcentaje de relleno de los objetos. En cuanto a la línea de contorno, además de los colores y las sombras, se comparan grosores de línea, pero no se analiza el tipo de línea.\nEn el criterio 'Mismo tamaño' la diferencia de tamaño no excede un punto. El programa analiza las dimensiones del objeto (cuadro delimitador), no el tamaño real; dos cuadrados idénticos girados en diferentes ángulos tendrán dimensiones no coincidentes y, por esta razón, no se mostrarán como objetos del mismo tamaño.\nSi la casilla de verificación 'Objetos del mismo tipo' está seleccionada, la ventana emergente de la casilla, luego de realizar la búsqueda, contendrá el nombre del tipo del objeto seleccionado.\n\nEl resultado de la búsqueda es un grupo seleccionado de objetos o un mensaje que indica que no se encontraron coincidencias. Si se encuentra alguna, se informa su cantidad en la ventana emergente del botón [?].\n\nLa referencia elegida se incluirá o no en la selección (si no es un objeto anclado), según el estado de la casilla de verificación a la izquierda del botón 'Buscar objetos'.\nMientras la selección basada en los resultados de la búsqueda esté activa, puede usar esta casilla de verificación para colocar el estándar de búsqueda en la selección o excluirlo de ella.\nCada vez que se cambia esta casilla de verificación, el color de relleno del cuadro de referencia cambia en la secuencia rojo-verde-azul, y luego se regresa al color original; este es un recordatorio de qué marco se seleccionó antes de buscar objetos similares.\n\nhttps://shop.dotextok.ru/en/  |  dotextok@gmail.com \n";
var m13 = "Resaltar objetos similares";
var m14 = "No hay coincidencias";
var m15 = "Coincidencias halladas: ";
var m16 = "No hay documentos abiertos";
var m17 = "Debe seleccionarse el objeto de referencia";
var m18 = "Un grupo de objetos no puede ser un elemento de referencia.";
var m19 = "El programa trabaja con estos objetos:";
var m20 = "El tipo del objeto seleccionado, '";
var m21 = "', no está en la lista de nombres de objetos procesados";
///

#targetengine "SameItemsSelection" 

var programTitul = m01;

var ProgressBar = function(title) { // ProgressBar
var w = new Window('palette', title, {x:0, y:0, width:740, height:58},{closeButton: true});
pb = w.add('progressbar', {x:20, y:37, width:700, height:12});
w.center();
this.reset = function(maxValue) {
    pb.value = 0; 
    pb.maxvalue = maxValue;
    w.show();
    w.update();
    };
this.set = function(value) {
    pb.value = value;
    w.show();
    w.update();
    };
this.hit = function() {++pb.value; w.update();};
this.hide = function() {w.hide();};
this.close = function() {w.close();};
} // ProgressBar
////////////////////////////
var pgIt;
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/ 
if (testOpenDoc () == null) exit();
var doc = app.activeDocument;
var sel;
var myCurrentHorUnits = doc.viewPreferences.horizontalMeasurementUnits;
var myCurrentVertUnits = doc.viewPreferences.verticalMeasurementUnits;
doc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
doc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
///
var constNames = "TextFrame, Rectangle, Polygon, GraphicLine, Oval";  
var founded = [];
while (founded.length > 0) founded.pop();
var actionID = -1;
var etalonP;
var theSpread;  
var pageItems = [];
var pageItemsLength;
while (pageItems.length > 0) pageItems.pop();
///
var w = new Window ("palette",programTitul);
w.alignChildren = ["fill", "fill"];
w.orientation = "column";
var titul = w.add("statictext", undefined, m02);
var fill = w.add("checkbox", undefined, m03);
fill.value = true;
var stroke = w.add("checkbox", undefined, m04);
stroke.value = true;
var os = w.add("checkbox", undefined, m05);  
os.value = false;
var sameLayers = w.add("checkbox", undefined, m06); 
sameLayers.value = false;
///
var sameTypes = w.add("checkbox", undefined, m07); 
sameTypes.value = false;
var sameSizes =  w.add("checkbox", undefined, m08);
sameSizes.value = false;
separator1 = w.add ("panel"); 
separator1.minimumSize.height = separator1.maximumSize.height = 1;
separator1.alignment = ["fill", "fill"]; 
var locked = w.add("checkbox", undefined, m09);
locked.value = false;
var buttonGroup = w.add("group");
buttonGroup.orientation = "row";
buttonGroup.alignChildren = ["fill", "bottom"];
var andEtalon = buttonGroup.add("checkbox");
andEtalon.helpTip = m10;
var action = buttonGroup.add("button", [0,0,125,28], m11);
buttonGroup.add("statictext", undefined, "");
var infoGroup = buttonGroup.add("group");
var info = infoGroup.add("button", [0,0,28,28], "?");
///
info.onClick = function () { // info.onClick
var infoText = m12;    
alert(infoText, m13);
} // info.onClick
///
function testCheckboxes () { // testCheckboxes
if (!fill.value && !stroke.value && !os.value && !sameSizes.value && !sameTypes.value  && !sameLayers.value) action.enabled = false; else action.enabled = true;
} // testCheckboxes
///
fill.onClick = function () { testCheckboxes (); }
///
stroke.onClick = function () { testCheckboxes (); }
///
os.onClick = function () { testCheckboxes (); }
///
sameSizes.onClick = function () { testCheckboxes (); }
///
sameLayers.onClick = function () { testCheckboxes (); }
///
sameTypes.onClick = function () { testCheckboxes (); }
///
action.onClick = function () { // action.onClick   
info.helpTip = "";
if (testOpenDoc() == null) return;
if (testSelelction() == null) return;
actionID = sel.id;
theSpread = doc.windows[0].activeSpread;  
pageItems = theSpread.pageItems.everyItem().getElements();
pageItemsLength = pageItems.length;
while (founded.length > 0) founded.pop();
pBar = new ProgressBar(programTitul);  
pBar.reset(pageItemsLength);
var selGB = sel.geometricBounds;
var selW = Math.abs(selGB[1] - selGB[3]);
var selH = Math.abs(selGB[0] - selGB[2]);
for (var p = 0; p < pageItemsLength; p++, pBar.hit()) { // p++
    if (pageItems[p].constructor.name == "Group") continue;
    if (constNames.match(pageItems[p].constructor.name) == null) continue;
    if (pageItems[p].id == actionID) { etalonP = p; continue; }
    if ((locked.value == true) && pageItems[p].itemLayer.locked) { continue; }    
    if ((fill.value == true) && ((pageItems[p].fillColor != sel.fillColor) || (pageItems[p].fillTint != sel.fillTint))) continue; 
    if ((stroke.value == true) && ((pageItems[p].strokeColor != sel.strokeColor) || (pageItems[p].strokeTint != sel.strokeTint) || (pageItems[p].strokeWeight != sel.strokeWeight))) continue;    
    if ((os.value == true) && (pageItems[p].appliedObjectStyle.id != sel.appliedObjectStyle.id)) continue;
    if ((sameTypes.value == true) && (pageItems[p].constructor.name != sel.constructor.name)) { continue; } 
    if ((sameLayers.value == true) && (pageItems[p].itemLayer.name != sel.itemLayer.name)) { continue; }     
    if (sameSizes.value == true) { // sameSizes.value
        var piGB = pageItems[p].geometricBounds;
        var piW = Math.abs(piGB[1] - piGB[3]);
        var piH = Math.abs(piGB[0] - piGB[2]);
        if ((Math.abs(selW - piW) > 1) || (Math.abs(selH - piH) > 1)) continue;
        } // sameSizes.value
    founded.push(p);    
    } // p++
pBar.close();
if (founded.length == 0) {
    alert(m14, programTitul);
    info.helpTip = "";
    return;
    }
else showSelection();
} // action.onClick
///
function showSelection () { // showSelection
info.helpTip = m15 + founded.length;    
app.selection = NothingEnum.NOTHING;
for (var f = 0; f < founded.length; f++) { app.select(pageItems[founded[f]], SelectionOptions.ADD_TO); }
if (andEtalon.value == false) app.select(pageItems[etalonP], SelectionOptions.ADD_TO);
} // showSelection
///
andEtalon.onClick = function () { // andEtalon.onClick
if (action.enabled == false) return; // все флажки сброшены  
if (app.selection[0] == null) return; // выделение снято
if (founded.length == 0 || pageItemsLength == 0) return; 
var usedColor, _r, _g, _b, _w;
usedColor = sel.fillColor;
 _r = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[255, 0, 0]});
 _g = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[0, 255, 0]});
 _b = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[0, 0, 255]});
 _w = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[255, 255, 255]});
var _time = 175;
sel.fillColor = _r; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = _g; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = _b; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = usedColor;
_r.remove(); 
_g.remove(); 
_b.remove(); 
_w.remove(); 
showSelection();
} // andEtalon.onClick
///
w.onClose = function () { // w.onClose
// try/catch  на случай, если файл закрыли, а окно программы осталось    
try {  
    doc.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
    doc.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
    }
catch (e) { }
} // w.onClose 
///
w.show();
/////////////
function testOpenDoc () { // testOpenDoc
if (app.documents.length == 0) {
    alert (m16,programTitul);
    return null;
    }    
 return 0;   
} // testOpenDoc
////
function testSelelction () { // testSelelction  
sel = app.selection[0];
if ((sel == null) || (sel.hasOwnProperty("geometricBounds") != true) || (app.selection.length !=1)) { // == null
    alert(m17,programTitul);
    return null;    
    }  // == null
var name = sel.constructor.name;
if (name == "Group") {
    alert(m18,programTitul);
    return null;     
    }
if (constNames.match(name) == null) {
    alert(m19 + "\n" + constNames + ".\n" + m20 + name + m21,programTitul);    
    return null;       
    }
app.documents[0].layoutWindows[0].zoom(ZoomOptions.FIT_SPREAD);
if (sameTypes.value == true) sameTypes.helpTip = sel.constructor.name; else sameTypes.helpTip = "";
return 0;
} // testSelelction    
////



